/////////////////////////////////////////////////////////////////////////////
// _IkoWnd.cpp

#include "stdafx.h"

#include "_IkoWnd.h"


/////////////////////////////////////////////////////////////////////////////
// IkoGetDllVersion()

IKOWND_API int IkoGetIWDllVersion()
{
	LPCSTR sFunctionName = "IkoGetDllVersion";

	typedef int (*IKO_PROC)( void );
	IKO_PROC ProcAdd;
	HINSTANCE hDll;

	int nReturn = 0;

	hDll = LoadLibraryA( m_sIkoWndDllA );
	if( hDll != NULL ){
		ProcAdd = (IKO_PROC) GetProcAddress( hDll, sFunctionName );

		if( ProcAdd != NULL ){
			nReturn = (ProcAdd) ();
		}

		iVERIFY( FreeLibrary( hDll ) );
	}

	return nReturn;
}



/////////////////////////////////////////////////////////////////////////////
// IkoHelpPopupWnd

IKOWND_API BOOL IkoHelpPopupWndW( LPCWSTR pText,
	LPPOINT pptWndPos,
	LPCOLORREF pclrWnd, LPCOLORREF pclrText,
	HFONT hHelpFont )
{
	LPCSTR sFunctionName = "IkoHelpPopupWndW";

	typedef BOOL (*IKO_PROC)( LPCWSTR,
		LPPOINT, LPCOLORREF, LPCOLORREF, HFONT );

	IKO_PROC ProcAdd;
	HINSTANCE hDll;
	int nDLLErrMode = 0;

	BOOL bReturn = FALSE;
	hDll = LoadLibraryW( m_sIkoWndDllW );
	if( hDll != NULL ){
		ProcAdd = (IKO_PROC) GetProcAddress( hDll, sFunctionName );

		if( ProcAdd != NULL ){
			bReturn = (ProcAdd) ( pText, pptWndPos, pclrWnd, pclrText,
				hHelpFont );
		}
		else{
			// DLL Ɋ֐Ȃ
			nDLLErrMode = 1;
		}

		iVERIFY( FreeLibrary( hDll ) );
	}
	else{
		// DLL Ȃ
	}

	return bReturn;
}


/////////////////////////////////////////////////////////////////////////////
// IkoHelpPopupWnd

IKOWND_API BOOL IkoHelpPopupWndA( LPCSTR pText,
	LPPOINT pptWndPos,
	LPCOLORREF pclrWnd, LPCOLORREF pclrText,
	HFONT hHelpFont )
{
	LPCSTR sFunctionName = "IkoHelpPopupWndA";

	typedef BOOL (*IKO_PROC)( LPCSTR,
		LPPOINT, LPCOLORREF, LPCOLORREF, HFONT );

	IKO_PROC ProcAdd;
	HINSTANCE hDll;
	int nDLLErrMode = 0;

	BOOL bReturn = FALSE;
	hDll = LoadLibraryA( m_sIkoWndDllA );
	if( hDll != NULL ){
		ProcAdd = (IKO_PROC) GetProcAddress( hDll, sFunctionName );

		if( ProcAdd != NULL ){
			bReturn = (ProcAdd) ( pText, pptWndPos, pclrWnd, pclrText,
				hHelpFont );
		}
		else{
			// DLL Ɋ֐Ȃ
			nDLLErrMode = 1;
		}

		iVERIFY( FreeLibrary( hDll ) );
	}
	else{
		// DLL Ȃ
	}

	return bReturn;
}


/////////////////////////////////////////////////////////////////////////////
// IkoHelpPopupWnd

IKOWND_API BOOL IkoHelpPopupWndW( UINT uResID, HINSTANCE hInst,
	LPPOINT pptWndPos,
	LPCOLORREF pclrWnd, LPCOLORREF pclrText,
	HFONT hHelpFont )
{
	LPCSTR sFunctionName = "IkoHelpPopupWndRW";

	typedef BOOL (*IKO_PROC)( UINT, HINSTANCE,
		LPPOINT, LPCOLORREF, LPCOLORREF, HFONT );

	IKO_PROC ProcAdd;
	HINSTANCE hDll;
	int nDLLErrMode = 0;

	BOOL bReturn = FALSE;
	hDll = LoadLibraryW( m_sIkoWndDllW );
	if( hDll != NULL ){
		ProcAdd = (IKO_PROC) GetProcAddress( hDll, sFunctionName );

		if( ProcAdd != NULL ){
			bReturn = (ProcAdd) ( uResID, hInst, pptWndPos, pclrWnd, pclrText,
				hHelpFont );
		}
		else{
			// DLL Ɋ֐Ȃ
			nDLLErrMode = 1;
		}

		iVERIFY( FreeLibrary( hDll ) );
	}
	else{
		// DLL Ȃ
	}

	return bReturn;
}


/////////////////////////////////////////////////////////////////////////////
// IkoHelpPopupWnd

IKOWND_API BOOL IkoHelpPopupWndA( UINT uResID, HINSTANCE hInst,
	LPPOINT pptWndPos,
	LPCOLORREF pclrWnd, LPCOLORREF pclrText,
	HFONT hHelpFont )
{
	LPCSTR sFunctionName = "IkoHelpPopupWndRA";

	typedef BOOL (*IKO_PROC)( UINT, HINSTANCE,
		LPPOINT, LPCOLORREF, LPCOLORREF, HFONT );

	IKO_PROC ProcAdd;
	HINSTANCE hDll;
	int nDLLErrMode = 0;

	BOOL bReturn = FALSE;
	hDll = LoadLibraryA( m_sIkoWndDllA );
	if( hDll != NULL ){
		ProcAdd = (IKO_PROC) GetProcAddress( hDll, sFunctionName );

		if( ProcAdd != NULL ){
			bReturn = (ProcAdd) ( uResID, hInst, pptWndPos, pclrWnd, pclrText,
				hHelpFont );
		}
		else{
			// DLL Ɋ֐Ȃ
			nDLLErrMode = 1;
		}

		iVERIFY( FreeLibrary( hDll ) );
	}
	else{
		// DLL Ȃ
	}

	return bReturn;
}



/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
